#include <sys/types.h>
#include <gtk/gtk.h>
#include <gtkextra/gtkextra.h>
#include <Python.h>
#include <grammar.h>
#include <node.h>
#include <parsetok.h>
#include <errcode.h>
#include <compile.h>
#include <eval.h>
#include <marshal.h>
#ifdef WITH_NUMERIC_PYTHON
#include <arrayobject.h>
#endif
#include "../main.h"
#include "python_int.h"

extern PyObject *main_o, *dict_o;

extern gint stdout_pipe[2];
gint py_status=0; /* 0=normal, 1=old line waiting */
extern grammar _PyParser_Grammar; /* From Python/graminit.c */
extern FILE *stdout_fp;
extern pid_t child_pid;
GString *com_buffer;

#ifndef Py_eval_input
#include <graminit.h>
#define Py_eval_input eval_input
#endif /* Py_eval_input */

int sg_eval_func(gchar *func_def, gdouble x_value, gdouble *y_value)
{ PyObject *object=NULL;
  gint len;

  object=Py_BuildValue("d",x_value);
  if (!object) return FALSE;
  PyDict_SetItemString (dict_o, "x", object);

  object=PyRun_String (func_def, Py_eval_input, dict_o, dict_o);
  if (!object)
   { if (PyErr_Occurred()) { PyErr_Print(); PyErr_Clear();}
     return FALSE;
   }

  *y_value=PyFloat_AsDouble (object);

  return TRUE;
}


int python_simple(gchar *command,gint count)
{ int retval,len;
  static PyObject *object=NULL;
  gchar *print_string,fn[]=PACKAGE,*s_str;
  node *parse_node;
  perrdetail perr;

  command[count]=0;
  if (py_status==0)
   com_buffer=g_string_new(command);
  else
   g_string_append(com_buffer,command);

  parse_node = PyParser_ParseString(com_buffer->str, &_PyParser_Grammar,
                                    Py_file_input,&perr);
  switch (perr.error)
  { case  E_EOF:
     py_status=1;
     return(2);
    case  E_DONE:
      if (command[0]=='\n')
       { if (parse_node) PyNode_Free(parse_node);
	 py_status=0;
	 g_string_free(com_buffer,TRUE);
	 return(1);
       }
    default:
     py_status=0;
     if (parse_node) PyNode_Free(parse_node);
  }

  object=PyRun_String (com_buffer->str, Py_single_input, dict_o, dict_o);

  if (!object){
      PyErr_Print();
      if (Py_FlushLine())
          PyErr_Clear(); 
      g_string_free(com_buffer,TRUE);
      return(0); 
  }
   
   
  Py_DECREF(object);
  g_string_free(com_buffer,TRUE);
 return(1);
}
