/*  SciGraphica - Scientific graphics and data manipulation
 *  Copyright (C) 2000 Adrian E. Feiguin <feiguin@ifir.edu.ar>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __SG_DATASET_H__
#define __SG_DATASET_H__

typedef struct _SGdataset SGdataset;

struct _SGdataset 
{
  SGworksheet *worksheet;
  gint x;
  gint y;
  gint dx;
  gint dy;
  gint l;

  GtkPlotData *real_data;

  gchar *exp;
};

SGdataset*	sg_dataset_new			(void); 
SGdataset*	sg_dataset_new_with_worksheet	(SGworksheet *worksheet, 
				 	 	 gint col_x,
					 	 gint col_y,
					 	 gint col_ex,
					 	 gint col_ey,
					 	 gint col_l);
SGdataset*      sg_dataset_new_function         (gchar *exp);
void		sg_dataset_set_worksheet	(SGdataset *dataset,
						 SGworksheet *worksheet, 
				 	 	 gint col_x,
					 	 gint col_y,
					 	 gint col_ex,
					 	 gint col_ey,
					 	 gint col_l);
void		sg_dataset_add_point		(SGdataset *dataset,
						 gdouble *x,
						 gdouble *y,
						 gdouble *ex,
						 gdouble *ey,
						 gchar *label); 
void		sg_dataset_refresh		(SGdataset *dataset); 
void		sg_dataset_free_points		(SGdataset *dataset); 
void		sg_dataset_destroy		(SGdataset *dataset); 
void		sg_dataset_set_name		(SGdataset *dataset,
						 gchar *name); 
void            sg_dataset_set_exp              (SGdataset *dataset,
                                                 gchar *exp);



#endif /* __SG_DATASET_H__ */
